/*
		NewRoom.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class corresponding to the dialog of the same name.
*/
#include "stdafx.h"
#include "Cbreak.h"
#include "NewRoom.h"
#include "World.h"
#include "utils.h"

#include <map>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// NewRoom dialog


NewRoom::NewRoom(CWnd* pParent /*=NULL*/)
	: CDialog(NewRoom::IDD, pParent)
{
	//{{AFX_DATA_INIT(NewRoom)
	m_new_room_num = 0;
	//}}AFX_DATA_INIT
}


void NewRoom::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(NewRoom)
	DDX_Text(pDX, IDC_NEW_ROOM_NUM, m_new_room_num);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(NewRoom, CDialog)
	//{{AFX_MSG_MAP(NewRoom)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NewRoom message handlers

extern CCbreakApp theApp;
extern World the_world;

void NewRoom::OnOK() 
{
  Room *new_room;
  map<int,Zone_Data>::const_iterator zi;
  int good=0,zone_num;

  UpdateData(TRUE);
  
	/* check if it's already existing */
  if(the_world.room_list.find(m_new_room_num)!= the_world.room_list.end()) {
	  AfxMessageBox("That room already exists!",MB_OK);
	  return;
  }
  /* check if it's in a zone or not */

  for(zi=the_world.zone_list.begin();zi != the_world.zone_list.end() && !good;zi++) {
    if(m_new_room_num >= zi->second.number * 100 && m_new_room_num <= zi->second.top) {
			good=1;
			zone_num = zi->second.number;
		}
  }

  if(!good) {
		AfxMessageBox("That room would exist outside a zone!",MB_OK);
	  return;
  }

	new_room = new Room;
	new_room->zone = zone_num;
	new_room->name = "An Empty Room";
	new_room->description = "Not Much Here";
	new_room->number = m_new_room_num;
	
	the_world.room_list[m_new_room_num] = *new_room;

	theApp.dlg->current_room = m_new_room_num;
	theApp.dlg->m_redit.LoadRedit();
	CDialog::OnOK();
}
